import json
from django.core.management.base import BaseCommand
from eventos.models import ListaEspera, Evento
from reymotausers.models import ReyMotaUser


class Command(BaseCommand):
    help = "Importa listaesperas desde un archivo JSON"

    def add_arguments(self, parser):
        parser.add_argument('archivo_json', type=str, help="Ruta del archivo JSON")

    def handle(self, *args, **kwargs):
        archivo_json = kwargs['archivo_json']

        try:
            with open(archivo_json, 'r', encoding='utf-8') as file:
                datos = json.load(file)

            self.stdout.write(self.style.WARNING(f"\nSe encontraron {len(datos)} listaesperas en el archivo '{archivo_json}'."))
            confirmar = input("¿Deseas continuar con la importación? (s/n): ").strip().lower()

            if confirmar != 's':
                self.stdout.write(self.style.ERROR("Importación cancelada."))
                return

            listaesperas_creados = 0
            for listaespera_data in datos:
                try:
                    evento = Evento.objects.get(nombre=listaespera_data["evento_nombre"])
                    usuario = ReyMotaUser.objects.get(email=listaespera_data["usuario_email"])

                    creado = ListaEspera.objects.create(
                        evento_id=evento.id,
                        usuario_id=usuario.id,
                        fecha_apuntado=listaespera_data['fecha_apuntado'],
                    )
                    if creado:
                        listaesperas_creados += 1

                except Evento.DoesNotExist:
                    self.stderr.write(self.style.ERROR(f"Evento '{listaespera_data['evento']}' no encontrado."))

                except ReyMotaUser.DoesNotExist:
                    self.stderr.write(self.style.ERROR(f"Usuario con email '{listaespera_data['usuario_email']}' no encontrado."))

            self.stdout.write(self.style.SUCCESS(f'Se importaron {listaesperas_creados} listaesperas correctamente.'))

        except FileNotFoundError:
            self.stderr.write(self.style.ERROR(f"El archivo {archivo_json} no se encontró."))
        except json.JSONDecodeError:
            self.stderr.write(self.style.ERROR("Error al leer el archivo JSON. Asegúrate de que el formato sea correcto."))
